=== deps/zlib-1.2.11/CMakeLists.txt ===
add_library(zlib STATIC
  zconf.h
  zlib.h
  adler32.c
  compress.c
  crc32.c
  crc32.h
  deflate.c
  deflate.h
  gzguts.h
  infback.c
  inffast.c
  inffast.h
  inffixed.h
  inflate.c
  inflate.h
  inftrees.c
  inftrees.h
  trees.c
  trees.h
  uncompr.c
  zutil.c
  zutil.h
)

target_include_directories(zlib PRIVATE "${CMAKE_CURRENT_SOURCE_DIR}/include")
target_include_directories(zlib INTERFACE "${CMAKE_CURRENT_SOURCE_DIR}/include")
