=== debian/changelog ===
libretro-beetle-pce-fast-dmo (0.9.38.7+git20201203-0.0) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 03 Dec 2020 14:32:58 +0100

libretro-beetle-pce-fast (0.9.38.7+git20160609-2) unstable; urgency=medium

  * Team upload
  * Import packaging to https://salsa.debian.org/
  * Add minimal debian/gbp.conf
  * Use dh-exec instead of manual .sh script for install file
  * Add .libretro file & AppStream metadata for integration with GNOME Games

 -- Jeremy Bicha <jbicha@debian.org>  Sat, 02 Mar 2019 17:42:54 -0500

libretro-beetle-pce-fast (0.9.38.7+git20160609-1) unstable; urgency=low

  * Updated to latest git, 095d63f.
  * Changed package maintainer to Debian Games Team.
  * Added patch to reproducible build (Closes: #827147).
  * Added patch to fix hardening-no-fortify-functions.
  * Removed shared libtrio patch (upstream removed this dependency).
  * Fixed hardening-no-bindnow.

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Sun, 12 Jun 2016 21:23:00 -0300

libretro-beetle-pce-fast (0.9.36.1+git20160324-1) unstable; urgency=low

  * Initial release (Closes: #814375).

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Thu, 02 Jun 2016 21:28:00 -0300
