=== debian/control ===
Source: libretro-beetle-pce-fast-dmo
Section: games
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://github.com/libretro/beetle-pce-fast-libretro
Standards-Version: 4.5.1
Build-Depends: debhelper-compat (= 13), zlib1g-dev, pkg-config

Package: libretro-beetle-pce-fast
Architecture: any
Multi-Arch: same
Depends: retroarch | libretro-frontend, ${misc:Depends}, ${shlibs:Depends}
Description: Libretro wrapper for the Beetle PCE FAST core
 This wrapper makes Beetle PCE FAST core API compatible with libretro, thus
 allowing its use with libretro frontends, such as RetroArch.
 .
 This core emulates the TurboGrafx-16 Entertainment SuperSystem, originally
 known in Japan as the PC Engine. It also emulates the TurboGrafx-CD
 (CD-ROM²).
 .
 Beetle PCE FAST is based in the Mednafen "pce_fast" module, so it has some
 tricks to speed up the hardware emulation, but with some loss in accuracy.
